// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
angular.module('involve-ionic', ['ui.router',
	'ngAnimate',
	'ngTouch',
	'popup.serverMessage',
	'popup.confirmation',
	'popup.cgu',
	'ui.mainComponent.titleBar',
	'ui.mainComponent.titleBarLogin',
	'ui.mainComponent.titleBarVerySmall',
	'ui.mainComponent.titleBarSmall',
	'ui.mainComponent.titleBarMedium',
	'ui.mainComponent.titleBarBig',
	'ui.mainComponent.titleBarProfile',
	'ui.mainComponent.tabBar',
	'ui.mainComponent.menu',
	'rest.userAccountService',
	'rest.userAccountPhotoService',
	'rest.writeUsService',
	'page.home',
	'page.login',
	'page.profile',
	'page.compte',
	'page.registration',
	'page.registered',
	'page.addEvent',
	'page.eventDetails',
	'page.nextEvents',
	'page.modifyEvent',
	'page.writeUs',
	'page.test',
	'ui.item.eventList',
	'ui.item.comment',
	'filter.ageFilter'])

.config(function($stateProvider, $urlRouterProvider, $httpProvider) {

	// pour désactiver requêtes options de merde
	$httpProvider.defaults.headers.common = {};
	$httpProvider.defaults.headers.post = {};
	$httpProvider.defaults.headers.put = {};
	$httpProvider.defaults.headers.patch = {};
	$httpProvider.defaults.headers.delete = {};

	$httpProvider.defaults.headers.post['Content-Type'] = 'application/json; charset=utf-8';

	$httpProvider.defaults.withCredentials = true;

	// $httpProvider.defaults.xsrfCookieName = "X-CSRF-TOKEN";
	// $httpProvider.defaults.xsrfHeaderName = "X-CSRF-HEADER";

	// $httpProvider.defaults.headers.common['Access-Control-Allow-Headers'] = 'X-CSRF-HEADER, X-CSRF-PARAM, X-CSRF-TOKEN';
	// $httpProvider.defaults.headers.common['Access-Control-Expose-Headers']
	// 	= 'X-CSRF-HEADER, X-CSRF-PARAM, X-CSRF-TOKEN';
	// $httpProvider.defaults.headers.common['Access-Control-Allow-Headers']
	// 	= "origin, content-type, accept, authorization, Access-Control-Expose-Headers, Access-Control-Allow-Headers, X-CSRF-HEADER, X-CSRF-PARAM, X-CSRF-TOKEN";

	// $httpProvider.defaults.headers.common['Access-Control-Allow-Origin']
	// 	= "http://127.0.0.1";

	// $httpProvider.defaults.headers.common['Accept']
	// 	= "http://127.0.0.1";

	$urlRouterProvider.otherwise("/home");

	if (navigator.splashscreen) {
		navigator.splashscreen.hide();
	}
})

.controller('involveIonicController',
		['$scope', 'userAccountService','credStorageService','loginService',
		function($scope, userAccountService,credStorageService,loginService) {


			document.addEventListener("resume", onResume, false);

			function onResume() {

				var cred = {};
				cred.password = credStorageService.getPassword();
				cred.username = credStorageService.getUserName();

				if(cred.password !=null && cred.username!=null) {

					loginService.login(cred).then(function(data) {
						},
						function(data) {
							console.log(data);
						});
				}
			}


	$scope.init = function() {
		userAccountService.getUserAccount(false, false).then(function(data){
			console.log(data);
		}, function(data){
			console.log(data);
		});
	};
	$scope.init();

	$scope.mainMenuExpanded = false;

	$scope.openMenu = function() {
		$scope.mainMenuExpanded = true;
	};

	$scope.closeMenu = function() {
		$scope.mainMenuExpanded = true;
	};
}]);
