
angular.module('core.csrfStrongholdService', [])

.factory('csrfStrongholdService', [function() {
	return {
		token : {},
		getHeaders : function() {
			console.log(this.token);
			return {
				"headers" : this.token
			};
		},
		getPushHeader : function(){
			var headers = {
				"X-CSRF-HEADER": this.token["X-CSRF-TOKEN"],
				"X-CSRF-PARAM": this.token["X-CSRF-TOKEN"],
				"X-CSRF-TOKEN": this.token["X-CSRF-TOKEN"],
				"_csrf" : this.token["X-CSRF-TOKEN"]
			};
			return headers;
		},
		getMultipartHeaders : function() {
			var headersWrapper = {
				"headers" : {
					"Content-Type": undefined,
					"X-CSRF-HEADER": this.token["X-CSRF-HEADER"],
					"X-CSRF-PARAM": this.token["X-CSRF-PARAM"],
					"X-CSRF-TOKEN": this.token["X-CSRF-TOKEN"]
				},
				"mimeType" : "image/jpeg"
			}
			console.log(headersWrapper.headers);
			return headersWrapper;
		},
		setToken : function(xCsrfHeader, xCsrfParam, xCsrfToken) {
			if (xCsrfHeader != null && xCsrfParam != null && xCsrfToken != null) {
				this.token = {
					"Content-Type": "application/json",
					"X-CSRF-HEADER" : xCsrfHeader,
					"X-CSRF-PARAM" : xCsrfParam,
					"X-CSRF-TOKEN" : xCsrfToken,

					// 'Access-Control-Allow-Origin': '127.0.0.1',
					// 'Access-Control-Allow-Methods' : 'GET, POST, OPTIONS, PUT, PATCH, DELETE',
  //   				'Access-Control-Allow-Headers': 'X-Requested-With,content-type'
				}
			}
		},
		handleResponse : function(data) {
			this.setToken(
				data.headers("X-CSRF-HEADER"),
				data.headers("X-CSRF-PARAM"),
				data.headers("X-CSRF-TOKEN")
				);
		}
	};
}]);
