
angular.module('page.eventDetails')

.controller('pageEventDetailsController', ['$scope',
											'$location',
											'$state',
											'$stateParams',
											'$cordovaGeolocation',
											'eventService',
											'pageEventDetailsService',
											'takePartService',
											'popupConfirmationService',
											'userAccountService',
											'geolocalizationService',
										function($scope,
												$location,
												$state,
												$stateParams,
												$cordovaGeolocation,
												eventService,
												pageEventDetailsService,
												takePartService,
												popupConfirmationService,
												userAccountService,
												geolocalizationService) {

	$scope.init = function() {
		$scope.connected = userAccountService.isConnected();
		if (pageEventDetailsService.getEntryEvent() === null) {
			$scope.event = {};
			$scope.event.pk = $state.params.pk;
		}
		else {
			$scope.event = pageEventDetailsService.getEntryEvent();
		}
		eventService.getDetails($scope.event.pk).then(function(data) {
			$scope.event = data.model;
		}, function(data) {
		});
		var posOptions = {timeout: 10000, enableHighAccuracy: false};
		$cordovaGeolocation
		.getCurrentPosition(posOptions)
		.then(function (position) {
				var lat  = position.coords.latitude
				var longi = position.coords.longitude
				$scope.distance = geolocalizationService.distance(lat, longi, $scope.event.latitude, $scope.event.longitude)
			}, function(err) {
	          // error
	      });
	};
	$scope.init();

	$scope.curTab = "detail";

	$scope.setCurTab = function(curTab) {
		$scope.curTab = curTab;
	};

	$scope.addCommentCallback = function(comment) {
		$scope.event.commentList.push(comment);
	};

	$scope.takePart = function() {
		//Temp****
		$scope.event.permissions.indexOf('takePart')
		//*******
		if(!userAccountService.isConnected()){
			$state.go("addEvent");
		}
		else{
			takePartService.takePart(
				$scope.event.pk
			).then(function() {
				try{
                $state.transitionTo($state.current, $stateParams, { reload: true, inherit: true, notify: true });    
            }catch(e){
                console.log(e);
            }

			}, function() {

			});
		}
	};

	$scope.deleteTakePart = function() {
		takePartService.deleteTakePart(
			$scope.event.pk
		).then(function() {
			try{
            $state.transitionTo($state.current, $stateParams, { reload: true, inherit: true, notify: true });    
            }catch(e){
                console.log(e);
            }

			}, function() {

			});
	};

	$scope.openDeleteEventPopup = function() {
		popupConfirmationService.openPopup("Etes-vous sûr de vouloir supprimer cet évènement ?", function() {
			eventService.delete($scope.event.pk).then( function() {
				$location.path('/nextEvents');
			}, function() {});
		});
	};

	$scope.goToModifyEvent = function() {
		$state.go("modifyEvent", {"pk" : $scope.event.pk});
	};

	$scope.goToFriendProfile = function(pkSelected) {
		$scope.init();
		$location.path('/profile/' + pkSelected);
	};
}]);
