
angular.module('page.test')

.controller('testController', ['$scope', 'eventService', 'userAccountService', 'csrfStrongholdService',
		function($scope, eventService, userAccountService, csrfStrongholdService){
	
	$scope.init = function() {
	};
	$scope.init();

	$scope.checkUser = function() {
		userAccountService.getUserAccount().then(function(data) {
			$scope.result = JSON.stringify(data);
		}, function(data) {
			$scope.result = JSON.stringify(data);
		});
	};

	$scope.postEvent = function() {

		eventService.add({
			"title" : "test",
			"dateBeginning" : 1594441974000,
			"longitude" : 0,
			"latitude" : 0,
			"accessControlType" : "PUBLIC",
			"maxParticipants" : 10,
			"address" : "...",
			"description" : "desc",
			"category" : "SPORT",
			"locationCategory" : "HOME",
		}).then(function(data) {
			$scope.result = JSON.stringify(data);
		}, function(data) {
			$scope.result = JSON.stringify(data);
		});
	};

	$scope.printToken = function() {
		$scope.result = JSON.stringify(csrfStrongholdService.token);
	};

	$scope.connectSock = function() {
		var socket = new SockJS('http://127.0.0.1:8080/web/web' + '/hello');
		this.stompClient = Stomp.over(socket);
		
		var headers = {};
 		headers["X-CSRF-HEADER"] = "X-CSRF-TOKEN";
 		headers["X-CSRF-PARAM"] = "_csrf";
 		headers["X-CSRF-TOKEN"] = csrfStrongholdService.token["X-CSRF-TOKEN"];
		headers["_csrf"] = csrfStrongholdService.token["X-CSRF-TOKEN"];

		var stompClient = this.stompClient;
		
		this.stompClient.connect(headers, function(frame) {
			console.log('Connected: ' + frame);
			console.log(stompClient.subscribe('/user/queue/reply', function(greeting) {
				showGreeting(JSON.parse(greeting.body).content);
			}));
			console.log(stompClient.subscribe('/user/topic/reply', function(greeting) {
				showGreeting(JSON.parse(greeting.body).content);
			}));
			console.log(stompClient.subscribe('/queue/reply', function(greeting) {
				showGreeting(JSON.parse(greeting.body).content);
			}));
			console.log(stompClient.subscribe('/topic/reply', function(greeting) {
				showGreeting(JSON.parse(greeting.body).content);
			}));
		});
	};

	$scope.disconnectSock = function() {
		if (this.stompClient != null) {
			console.log(this.stompClient.disconnect());
		}
		console.log("Disconnected");
	}
}]);