
angular.module('rest.eventService', [ 'core.csrfRequestService' ])

.factory('eventService', ['csrfRequestService', function(csrfRequestService) {
	return {
		add : function(event, messageSuccessHandler, messageErrorHandler) {
			return csrfRequestService.post(
					'rest/private/event',
					event,
				 messageSuccessHandler, messageErrorHandler);
		},
		
		delete : function(pk, messageSuccessHandler, messageErrorHandler) {
			return csrfRequestService.delete(
					'rest/private/event',
					pk,
				messageSuccessHandler, messageErrorHandler);
		},

		put : function(pk, event,  messageSuccessHandler, messageErrorHandler) {
			return csrfRequestService.put(
				'rest/private/event',
				{pk : pk},
				event,
				messageSuccessHandler,
				messageErrorHandler);
		},
		
		getMyEventList : function( messageSuccessHandler, messageErrorHandler) {
			return csrfRequestService.get('rest/private/event/myEventList',
					null, messageSuccessHandler, messageErrorHandler);
		},
		
		getDetails : function(pk, messageSuccessHandler, messageErrorHandler) {
			return csrfRequestService.get('rest/public/event/details',
					{pk : pk},
					 messageSuccessHandler, messageErrorHandler);
		},
		
		getSampleEventList : function(messageSuccessHandler, messageErrorHandler) {
			return csrfRequestService.get('rest/public/event/all',
				null,
				 messageSuccessHandler, messageErrorHandler);
		},

		getHomeEventList : function(messageSuccessHandler, messageErrorHandler) {
			return csrfRequestService.get('rest/public/event/homeEventList',
				null,
				messageSuccessHandler, messageErrorHandler);
		},

		testOptions : function(event, messageSuccessHandler, messageErrorHandler) {
			return csrfRequestService.options(
					'rest/private/event',
					event,
					 messageSuccessHandler, messageErrorHandler);
		}
	};
}]);
