
angular.module('rest.geolocalizationService', [])

.factory('geolocalizationService', [ function() {
	return {
		position : {
			longitude : 0,
			latitude : 0
		},
		
		geolocalize : function() {
			if (navigator.geolocation) {
				var success;
				navigator.geolocation.getCurrentPosition(function(position) {
					this.position.longitude = position.coords.longitude;
					this.position.latitude = position.coords.latitude;
					success = true;
				},
				function() {
					// TODO : enlever alerte
					alert("géolocalisation refusée");
					success = false;
				});
				return success;
			}
			else {
				// TODO : enlever alerte
				alert("géolocalisation non supportée");
				return false;
			}
		},

		distance : function(lat1, lon1, lat2, lon2){
			 var R = 6371; // Radius of the earth in km
  			 var dLat = (lat2-lat1)* (Math.PI/180);  // deg2rad below
 			 var dLon = (lon2-lon1)* (Math.PI/180); 
  			 var a = 
    		 Math.sin(dLat/2) * Math.sin(dLat/2) +
    		 Math.cos(lat1* (Math.PI/180)) * Math.cos(lat2* (Math.PI/180)) * 
    		 Math.sin(dLon/2) * Math.sin(dLon/2)
             ; 
             var c = 2 * Math.atan2(Math.sqrt(a), Math.sqrt(1-a)); 
             var d = R * c; // Distance in km
             return d;
		}
	};
}]);
