
angular.module('rest.takePartService', [ 'core.csrfRequestService'])

.factory('takePartService', ['csrfRequestService', function(csrfRequestService){
	return {
		takePart : function(eventPk,messageSuccessHandler, messageErrorHandler) {
			return csrfRequestService.post(
				'rest/private/takePart',
				eventPk,
				messageSuccessHandler,
				messageErrorHandler
				);
		},
		deleteTakePart : function(eventPk, messageSuccessHandler, messageErrorHandler) {
			return csrfRequestService.delete(
				'rest/private/takePart',
				eventPk,
				messageSuccessHandler,
				messageErrorHandler
				);
		},
		acceptParticipant : function(takePart, messageSuccessHandler, messageErrorHandler) {
			return csrfRequestService.put(
				'rest/private/takePart/accept',
				null,
				takePart,
				messageSuccessHandler,
				messageErrorHandler);
		},
		rejectParticipant : function(takePart, messageSuccessHandler, messageErrorHandler) {
			return csrfRequestService.delete(
				'rest/private/takePart/reject',
				null,
				takePart,
				messageSuccessHandler,
				messageErrorHandler);
		}
	};
}])