angular.module('rest.userAccountService', [ 'core.csrfRequestService'])

.factory('userAccountService', [ '$rootScope', '$state', '$stateParams', 'csrfRequestService',
		function($rootScope, $state, $stateParams, csrfRequestService) {
	return {
		userAccount : null,
		getUserAccount : function( messageSuccessHandler, messageErrorHandler) {
			console.log("getUserAccount");
			var userAccountService = this;
			return csrfRequestService.get(
					'rest/private/userAccount/own',
					null,
					messageSuccessHandler, messageErrorHandler).then(function(data) {
					if(data != "" && data != null & data != undefined) {
						userAccountService.userAccount = {
							"pk" : data.model
						};
						try {
							$state.transitionTo($state.current, $stateParams, { reload: true, inherit: true, notify: true });
						} catch (e) {

						}
						console.log("event loggedIn");
						$rootScope.$broadcast('loggedIn', data);

					}
				},
				function(data) {
					userAccountService.userAccount = null;
					$rootScope.$broadcast('loggedOut', data);

				});
		},
		/**
		*Get all information about the user
		*/
		getAnUserAccount : function(pk, messageSuccessHandler, messageErrorHandler) {
			console.log("getUserAccount");
			var userAccountService = this;
			 return csrfRequestService.get(
					'rest/private/userAccount',
					{pk : pk}
					, messageSuccessHandler, messageErrorHandler, function(data) {
					userAccountService.userAllAcount = data.data;
					// TODO : trouver une autre solution avec le router
					// $route.reload();
					try {
						$state.transitionTo($state.current, $stateParams, { reload: false, inherit: true, notify: true });
					} catch (e) {

					}

				},
				function(data) {
					// userAccountService.userAccount = null; // (On garde le userAccount afin de l'utiliser dans la suite !)
				});
		},

		/**
		*Get all information about the user
		*/
		getInformationsUtilisateur : function(messageSuccessHandler, messageErrorHandler) {
			console.log("getListInvitation");
			 return csrfRequestService.get(
					'rest/private/userAccount/own/details',
					null,
					 messageSuccessHandler, messageErrorHandler);
		},

		getUserAccountDetails : function(pk, messageSuccessHandler, messageErrorHandler) {
			console.log("getUserAccountDetails");
			return csrfRequestService.get(
				'rest/private/userAccount/details',
				{pk : pk},
				messageSuccessHandler, messageErrorHandler
				);
		},

		getUserAccountOwnDetails : function(messageSuccessHandler, messageErrorHandler) {
			console.log("getUserAccountOwnDetails");
			return csrfRequestService.get(
				'rest/private/userAccount/own/details',
				null,
				messageSuccessHandler, messageErrorHandler
				);
		},

		acceptFriend : function(pk,  messageSuccessHandler, messageErrorHandler) {		
			return csrfRequestService.post(
					'rest/private/isFriend/friendAcceptClaim',
					pk
					, messageSuccessHandler, messageErrorHandler);
		},

		refuseFriend : function(pk,  messageSuccessHandler, messageErrorHandler) {		
			return csrfRequestService.delete(
					'rest/private/isFriend/friendRejectClaim',
					pk
					, messageSuccessHandler, messageErrorHandler);
		},

		cancelClaim : function(pk,  messageSuccessHandler, messageErrorHandler) {		
			return csrfRequestService.delete(
					'rest/private/isFriend/friendCancelClaim',
					pk
					, messageSuccessHandler, messageErrorHandler);
		},

		deleteFriend : function(pk, messageSuccessHandler, messageErrorHandler) {
			return csrfRequestService.delete(
					'rest/private/isFriend/friendDelete',
					pk,
					messageSuccessHandler, messageErrorHandler);
		},
				
		changePassWord : function(model,messageSuccessHandler, messageErrorHandler){

			var userAccountService = this;
			return csrfRequestService.put(
					'rest/private/password',
					null, model, messageSuccessHandler, messageErrorHandler).then(function(data) {
					// TODO : trouver une autre solution avec le router
					// $route.reload();
					/*try {
						$state.transitionTo($state.current, $stateParams, { reload: false, inherit: true, notify: true });
					} catch (e) {

					}*/
				},
				function(data) {
				});

		},
		getLocalUserAccount : function(successCallback, errorCallback) {
			successCallback(this.userAccount);
		},
		isConnected : function() {
			return (this.userAccount === null || this.userAccount === undefined) === false;
		},

		addFriend : function(model,messageSuccessHandler, messageErrorHandler){
			var userAccountService = this;
			return csrfRequestService.post(
					'rest/private/isFriend/friendPost',
					model
					, messageSuccessHandler, messageErrorHandler);
		}
	};
}]);
