'use strict';

angular.module('ui.form.partner')

    .controller('uiFormPartnerController', ['$scope',
        'partnerEventService',
        '$cordovaGeolocation',
        'geolocalizationService',
        function ($scope,
                  partnerEventService,$cordovaGeolocation,geolocalizationService) {

        	$scope.partnerChoice = null;
            $scope.init = function () {
            	partnerEventService.getPartnerByCategory($scope.event.category).then(function (data) {
                    $scope.partnerList = data.model;

                }, function (data) {
                });
            };
            $scope.init();

            $scope.initFields = function() {
            	if ($scope.partnerChoice != null) {
            		$scope.event.title = $scope.partnerChoice.title;
            		$scope.event.address = $scope.partnerChoice.address;
                    $scope.event.latitude = $scope.partnerChoice.latitude;
                    $scope.event.longitude = $scope.partnerChoice.longitude;
            		$scope.event.description = $scope.partnerChoice.description;
            	}
            	return true;
            };

            $scope.updatePartner = function(partner) {
            	$scope.partnerChoice = partner;
            };


            $scope.initDistance = function() {
                //Récupérer l'adresse de l'utilisateur
                var posOptions = {timeout: 10000, enableHighAccuracy: false};
                $cordovaGeolocation
                    .getCurrentPosition(posOptions)
                    .then(function (position) {
                        var lat  = position.coords.latitude
                        var longi = position.coords.longitude
                        $scope.distance = geolocalizationService.distance(lat, longi, $scope.partnerChoice.latitude, $scope.partnerChoice.longitude)
                    }, function(err) {
                        // error
                    });
            };

            $scope.initDistance();

        }]);