
angular.module('ui.form.titleWhenMoney')

.controller('uiFormTitleWhenMoneyController', ['$scope',
                                        function($scope) {
	
    $scope.init = function() {
    	if ($scope.event != null && $scope.event.dateBeginning != null) {
            var dateBg = new Date($scope.event.dateBeginning)
			$scope.timeBeginning = {
                hours : dateBg.getHours(),
                minutes : dateBg.getMinutes()
            };
            $scope.dateBeginning = {
                year : dateBg.getFullYear(),
                month : dateBg.getMonth(),
                day : dateBg.getDate()
            };
    	}
    	else {
    		var curDate = new Date();
    		curDate.setMilliseconds(0);
    		curDate.setSeconds(0);
			$scope.timeBeginning = {
                hours : curDate.getHours(),
                minutes : curDate.getMinutes()
            };
            $scope.dateBeginning = {
                year : curDate.getFullYear(),
                month : curDate.getMonth(),
                day : curDate.getDate()
            };
    	}

    	$scope.minDate = new Date();
    	$scope.minDate.setHours(0);
    	$scope.minDate.setMinutes(0);
    	$scope.minDate.setSeconds(0);
    	$scope.minDate.setMilliseconds(0);
        $scope.time = {};

        //V1 : on choisit par défaut "Public" et "Dehors" comme type d'évènement:
        $scope.event.accessControlType = 'PUBLIC'
        $scope.event.locationCategory = 'OUTSIDE'
    };
    $scope.init();
	
	$scope.updateDateBeginning = function() {
		if ($scope.dateBeginning != null && $scope.dateBeginning != undefined 
			&& $scope.timeBeginning != null && $scope.timeBeginning != undefined) {
            $scope.event.dateBeginning = new Date(
                $scope.dateBeginning.year,
                $scope.dateBeginning.month,
                $scope.dateBeginning.day,
                $scope.timeBeginning.hours,
                $scope.timeBeginning.minutes,
                0, 0, 0, 0);
		}
	};
	$scope.updateDateBeginning();
}]);