
angular.module('ui.item.friend')

.controller('uiItemFriendController', ['$scope',
		'$location',
		'$cordovaGeolocation',
		'$state',
        '$stateParams',
		"$controller",
		'pageEventDetailsService',
		'geolocalizationService',
		'userAccountService',
		function($scope, $location, $cordovaGeolocation, $state, $stateParams, $controller, pageEventDetailsService, geolocalizationService, userAccountService) {
	
	
	$scope.goToFriendProfile = function() {
		$location.path('/profile/' + $scope.friend.pk);
	};

    $scope.addAsFriend = function() {

        userAccountService.addFriend(
                $scope.friend.pk)
        .then(
        function(data) {
            console.log(data);
            try{
                $state.transitionTo($state.current, $stateParams, { reload: true, inherit: true, notify: true });    
            }catch(e){
                console.log(e);
            }
        },
        function(data) {
            console.log(data);
        });
    };

    $scope.acceptFriend = function() {

        userAccountService.acceptFriend(
                $scope.friend.pk).then(
                function(data) {
                    try{
                        $state.transitionTo($state.current, $stateParams, { reload: true, inherit: true, notify: true });    
                    }catch(e){

                    }
                    
                    console.log(data);
                },
                function(data) {
                    console.log(data);
                });
    };

    $scope.refuseFriend = function() {

        userAccountService.refuseFriend(
                $scope.friend.pk).then(
                function(data) {
                    try{
                        $state.transitionTo($state.current, $stateParams, { reload: true, inherit: true, notify: true });    
                    }catch(e){
                        console.log(e);
                    }
                    console.log(data);
                },
                function(data) {
                    console.log(data);
                });
    };

    $scope.cancelClaim = function() {

        userAccountService.cancelClaim(
                $scope.friend.pk).then(
                function(data) {
                    try{
                        $state.transitionTo($state.current, $stateParams, { reload: true, inherit: true, notify: true });    
                    }catch(e){
                        console.log(e);
                    }
                    console.log(data);
                },
                function(data) {
                    console.log(data);
                });
    };

    $scope.deleteFriend = function() {

        userAccountService.deleteFriend($scope.friend.pk)
        .then(
        function(data) {
            try{
                $state.transitionTo($state.current, $stateParams, { reload: true, inherit: true, notify: true });    
            }catch(e){
                console.log(e);
            }
            console.log(data);
        },
        function(data) {
            console.log(data);
        });
    }

}]);
