
angular.module('ui.mainComponent.menu')

.controller('uiMainComponentMenuController', ['$scope', '$location', 'userAccountService',
		'loginService',
		function($scope, $location, userAccountService, loginService) {
	
	$scope.reloadConnected = function() {
		$scope.connected = userAccountService.isConnected();
	};
	
	$scope.init = function() {
		$scope.reloadConnected();
	};
	$scope.init();
	
	$scope.$on('loggedIn', function(event, data) {
		$scope.connected = true;
	});
	
	$scope.$on('loggedOut', function(event, data) {
		$scope.connected = false;
	});
	
	$scope.closeMenu = function() {
		$scope.mainMenuExpanded = false;
	};
	
	$scope.goToLogin = function() {
		$scope.closeMenu();
		$location.path('/login');
	};
	
	$scope.goToRegistration = function() {
		$scope.closeMenu();
		$location.path('/registration');
	};

	$scope.goToProfile = function() {
		$scope.closeMenu();
		$location.path('/profile/' + userAccountService.userAccount.pk);
	};

	$scope.goToWriteUs = function() {
		$scope.closeMenu();
		$location.path('/writeUs');
	};

	$scope.goToCompte = function(){
		$scope.closeMenu();
		$location.path('/compte');
	};

	$scope.goToTest = function() {
		$scope.closeMenu();
		$location.path('/test');
	};
	
	$scope.logout = function() {
		loginService.logout().then(function(data) {
			$scope.closeMenu();
		}, function(data) {
			$scope.closeMenu();
		});
	};
}]);
